//////////////////////////////////////////////////////////////////////////
//                                                                      //
// asin.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:06p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

//         
//  (    )
extern ULONG _DASINKK[26];

//   
//  iDTBL[i] = atan(1./pow(2,i)) * ((LONG)1 << i) * 0x4000000000000000
extern LONG _iDTBL[90];

#ifdef __cplusplus
extern "C" {
#endif

// asin --
//
//    
//
//    --.
//    CORDIC,    .

double asin (double f){
	LONG Mnt;               //   
    LONG x, y;              //    
    LONG t;                 //       
    LONG YKK;               //    * y
    LONG atan;              //      
	int Exp, Sgn;           //     
	int NewExp;             //   
	int i;                  //     
    int j;                  //  ,    
	LONG rez = 0;           //   
	int iMj, iPj;           //      i-j, i+j

    //   double
	DstrDouble( f, Mnt, Exp, Sgn );

	//  
	if ( !Exp && Mnt == 0x0010000000000000  )	// +-1:  +-pi/2	
		return ConstructDouble( 0x001921fb54442d18, 0, Sgn, 0);

	if ( Exp >-1  ){	// |x|>1 :  NAN
		_FPIEEE_Signal( _FPIEEE_Invalid ); 
		return ConstructDouble( 1, 0x400, 0, 0);
	}

	if ( Exp < -25 )			//    
		return f;			//	lim(x->0)(sin(x)) = x

	//     
	x = 0x2000000000000000;
	y = 0;

    //      ( )
    NewExp = Exp+1;
	j=-NewExp;
	i=j;
		//      . 
	YKK = LONG(double(Mnt<<8) * (*(double*)&_DASINKK[j]));

    //    CORDIC,    .
	while (i<64-j){
		iMj = i - j;
		atan = _iDTBL[i]>>iMj;
		iPj = i + j;
		t = x;						//  
		if ( (y>=YKK) ^ (x<=0) ){
			x += y>>iPj;		//  
			y -= t>>iMj;
			rez -= atan;
		}
		else{
			x -= y>>iPj;		//  
			y += t>>iMj;
			rez += atan;
		}
		t = x;						//  
		if ( (y>=YKK) ^ (x<=0) ){
			x += y>>iPj;		//  
			y -= t>>iMj;
			rez -= atan;
		}
		else{
			x -= y>>iPj;		//  
			y += t>>iMj;
			rez += atan;
		}
		i++;
	}
	while (i<64+j){		/*  ?  -  i<64-NewExp
						x  ,    (microsoft ++(r))	-
						    .*/
		iMj = i - j;
		atan = _iDTBL[i]>>iMj;
		if ( (y>=YKK) ^ (x<=0) ){
			y -= x>>iMj;		//  
			rez -= atan;
		}
		else{
			y += x>>iMj;		//  
			rez += atan;
		}
		if ( (y>=YKK) ^ (x<=0) ){	//  
			y -= x>>iMj;		//  
			rez -= atan;
		}
		else{
			y += x>>iMj;		//  
			rez += atan;
		}
		i++;
	}
    //  asin(x) = 2*Pi - asin(x)
	if (rez>0x3243f6a8885a308d)
		rez = 0x6487ed5110b4611a - rez;

    //      
    if (rez!=0){
		while (!(rez & 0x2000000000000000)){
			rez <<= 1;
			NewExp--;
		}
	}
	else
		NewExp = -0x3ff;

	//     , ...  
	rez >>=8;

	if (NewExp<-14)
		rez++;

	//    ,  .
	rez = (rez>>1) + (rez & 1);

	if (rez == 0x0020000000000000){
		rez = 0;
		NewExp++;
	}
    //   double
	return ConstructDouble( rez, NewExp, Sgn, 0);		
}

#ifdef __cplusplus
}
#endif
