//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                           faux.asm                                       //
//                                                                          //
//      float .                          //
// FFrExp  -    float    .            //        
// FResult -        float   //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 27.11.97 )
// : 
// :   2    .    
//   

global FFrExp   :label;
global FResult  :label;

extern RShift64 :label;
extern __FPIEEE_Flags       :word;
extern __FPIEEE_RoundMode   :word;


import FPIEEE_FLAGS_DEF from rtmacro;

FPIEEE_FLAGS_DEF();


begin text

//======  FFrExp ======
//    float    .
//  :         -   float.
//  0 = SP    
// -1 = PSW
// -2 = PC
// -3 = 
// -4 =   
// -5 =     FFrExp
//  :     -  + 127,
//                -  ( ),
//              gr7 -   :
//                  0 -  ,
//                  1 - ,
//                  0ffffffffh - quiet NaN,
//                  080000000h - signaling NaN.
//       .
//  0 = SP    
// -1 =  + 127
// -2 =   
// -3 =     FFrExp
// :    ar5, gr7.
<FFrExp>
    ar5 = sp;
    push ar0,gr0;
    gr7 = [ ar5 -= 3 ];         // 
    with gr0 = gr7 << 1;
    with gr0 >>= 24;            //  + 127
    if =0 delayed skip Denorm
        with gr7 <<= 9;
    with gr7 >>= 9;             // 
    nul;
    // cond. skip Denorm
    push ar1,gr1;
    [ ar5 ] = gr0;              //  + 127   
    gr1 = 0ffh;
    with gr0 - gr1;
    pop ar1,gr1;
    if =0 delayed skip Abnormal;
    gr0 = 00800000h;
    pop ar0,gr0
        with gr7 += gr0;        //  1   
    delayed return;
    [ --ar5 ] = gr7 with gr7 = false;  //  
    nul;
    // return;

<Denorm>        //  
    gr0++;      //  1 - 127 = -126
    [ ar5 ] = gr0;              //  
    pop ar0,gr0;
    delayed return;
    [ --ar5 ] = gr7 with gr7 = false;
    nul;
    // return;
<Abnormal>
    with gr7;
    if <>0 skip NaN;
    pop ar0,gr0;
    delayed return;
    [ --ar5 ] = gr7 with gr7++; // 1
    nul;
    // return;
<NaN>
    gr0 = 007fffffh;
    with gr7 - gr0;
    if =0 skip QuietNaN;

    gr7 = [__FPIEEE_Flags];
    gr0 = _FPIEEE_Invalid;
    gr7 = gr0 or gr7;
    [__FPIEEE_Flags] = gr7;

    pop ar0,gr0;        //     ar0,gr0
    delayed return;     //   - 2  
    gr7 = 80000000h;
    // return;

<QuietNaN>
    pop ar0,gr0;        //     ar0,gr0
    return with gr7 = true;

//======  FResult ======
//         float.
//  :    gr1 - 9   23   ,
//              gr0 - 32   ,
//              gr2 -  + 127,
//              gr3 -       
//                     (     0,  0),
//              gr4 - .
//  :   gr7 -   float.
//  :    __FPIEEE_Flags.
// : gr0, gr1, gr2, gr3, gr4.
<FResult>
    gr7 = 00800000h;
    with gr1 - gr7;
    if u< skip Smaller;

    gr7 <<= 1;  // 01000000h;
    with gr1 - gr7;
    if u< skip CheckTininess
        with gr2;
    push ar5,gr5
        with gr5 = false;
<LLoop>
    gr1 >>= 1;
    gr0 C>>= 1;
    gr5 C<<= 1;     //   
    with gr1 - gr7;
    if u>= delayed skip LLoop
        with gr3 = gr3 or gr5;  //   ,    gr3
    gr2++;
    nul;
    // cond. skip LLoop
    pop ar5,gr5;

<CheckTininess>
    if > skip CheckExact;

<Tiny>
    push ar0,gr0
        with gr7 = gr2 - 1;
    push ar1,gr1
        with gr7 = -gr7;
    call RShift64;
    pop ar1,gr1;
    pop ar0,gr0;
    with gr1 or gr0;
    if <>0 skip CheckUnderflow;

        //    ,      gr3
    gr3 = gr3 or gr0;
    gr3 = gr3 or gr1;
<CheckUnderflow>
    gr2 = 1
        with gr0 or gr3;
    if =0 skip ResAfter;     //  
    gr7 = [__FPIEEE_Flags];
    gr3 = _FPIEEE_Underflow;    // gr3 <> 0,     ,  
    delayed skip Round
        with gr7 = gr7 or gr3;
    [__FPIEEE_Flags] = gr7;
    // skip Round;

<Smaller>
    with gr0 or gr1;
    if =0 skip CheckExact
        with gr2 - 1;
<SLoop>
    if <= skip Tiny;
    gr0 <<= 1;
    gr1 C<<= 1;
    with gr1 - gr7;
    gr2-- noflags;
    if u< skip SLoop
        with gr2 - 1;

<CheckExact>
    with gr0 or gr3;
    if =0 delayed skip CheckOverflow;   //  
<Round>
    gr7 = [__FPIEEE_RoundMode];
    with gr7;
    if <>0 skip R1
        with gr7--;

        // round to nearest
    gr7 = gr0 << 1;
    if not carry skip Inexact
        with gr7 or gr3;
<AddOne>    //     - 
    if <>0 skip InexactWithOne
        with gr1++;

            //  ;    
    delayed skip InexactWithOne;
    gr1 >>= 1;
    gr1 <<= 1;
    // skip InexactWithOne;

<R1>
    if =0 skip Inexact;
        // rounding toward 0 -  

    gr7--;
    if <>0 skip R3
        with gr4;

        // rounding toward +Inf
    if < skip Inexact;  //   - 
    skip InexactWithOne
        with gr1++;

<R3>    // rounding toward -Inf
    if >= skip Inexact;  //   - 
    gr1++;

<InexactWithOne>    //    
    gr7 = 01000000h;
    with gr1 - gr7;     //      24- ?
    if <>0 skip Inexact;
    gr1 >>= 1;          //  , 
    gr2++;

<Inexact>   //  
    gr7 = [__FPIEEE_Flags];
    gr3 = _FPIEEE_Inexact;
    gr7 = gr7 or gr3;
    [__FPIEEE_Flags] = gr7;

<CheckOverflow>
    gr7 = 255;
    with gr2 - gr7;
    if >= skip Overflow;

    gr7 = 00800000h;
    with gr1 - gr7;
    if u< delayed skip ResAfter;
    gr1 <<= 9;
    gr1 >>= 9;
    // cond. skip ResAfter
    gr2 <<= 23;
    gr1 = gr1 or gr2;
<ResAfter>
    delayed return;
    gr7 = gr4 >> 31;
    gr7 <<= 31;
    gr7 = gr7 or gr1;
    // return;

<Overflow>
    gr7 = [__FPIEEE_Flags];
    gr3 = _FPIEEE_Overflow;
    gr0 = [__FPIEEE_RoundMode]
        with gr7 = gr7 or gr3;
    [__FPIEEE_Flags] = gr7
        with gr0;
    if <>0 delayed skip OF1
        with gr0--;
    gr7 = 7f800000h;
    // cond. skip OF1

        // overflow with rounding to nearest
    delayed return;
    gr4 >>= 31;
    gr4 <<= 31;
    gr7 = gr7 or gr4;
    // return;

<OF1>
    if <>0 skip OF2
        with gr0--;

        //  overflow with rounding toward 0
    delayed return
        with gr7--;
    gr4 >>= 31;
    gr4 <<= 31;
    gr7 = gr7 or gr4;
    // return;

<OF2>
    if =0 delayed skip OF3
        with gr4;
    gr0 = 80000000h;

        //  overflow with rounding toward +Inf
    if >= return;
    delayed return
        with gr7--;
    gr7 = gr7 or gr0;
    nul;
    // return;

<OF3>
        //  overflow with rounding toward -Inf
    if < return
        with gr7 = gr7 or gr0;
    return
        with gr7--;
    // return;

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                         faux.asm                               //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
