//////////////////////////////////////////////////////////////////////////
//                                                                      //
// frexp.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:07p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif

// frexpff --
//
//     
//
double frexp(double f, int* ip){
	LONG m; 
	int	e, s;

    //   float
    DstrDouble(f, m, e, s);
	if (e == 0x400){    // NAN, inf
		*ip=-1;
		return f;       //  ConstructDouble(0x1fffffffffffff, 0x400, s, 0);	
	}
	if (m){
		if (!(m & 0x10000000000000)){
			while ( !(m & 0x10000000000000)){
				m<<=1;				// Denormal
				e--;
			}
			e++;
		}
		e++;
	}
	else if (e == -0x3ff){
		*ip=0;
		return f;
	}
	*ip = e;

    //   double
	return ConstructDouble(m, -1, s, 0);
}

#ifdef __cplusplus
}
#endif
