//////////////////////////////////////////////////////////////////////////
//                                                                      //
// frexpf.cpp -                                                         //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:07p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif

// frexpf --
//
//     
//
float frexpf(float f, int* ip){
	int m, e, s, sc;

    //   float
	DestructFloat(f, m, e, s, sc);
	if (e == 128){		//  NAN, inf
		*ip=-1;
		return f;       //  ConstructFloat(0x7fffff, 128, s, 0);	
	}
	if (m){
		if (!(m & 0x800000)){
			while ( !(m & 0x800000)){
				m<<=1;				// Denormal
				e--;
			}
			e++;
		}
		e++;
	}
	else if (e == -127){
		*ip=0;
		return f;
	}
	*ip = e;
	//   float
    return ConstructFloat(m, -1, s, 0);
}

#ifdef __cplusplus
}
#endif
