//    
//        
//      

const TM0 = 080000h;  //    0    (19 bit)
const TE0 = 040000h;  //    0 (18 bit)
const TM1 = 020000h;  //    1    (17 bit)
const TE1 = 010000h;  //    1 (16 bit)

const TEN = 020000000h;  //      TIMER
const TPOC = 01c000000h;  //   ,   
                          //   TIMER
const tmp1 = 07h;

begin text

    global _UnIntptTimerMode : label;
    global _IntptTimerMode : label;
    global _ClearTimerCtrl : label;
    global _SetTimerCtrl : label;
    global _SetTimerCounter : label;
    global _GetTimerCounter : label;

    global _TimerPinHalt : label;
    global _TimerPinRelease : label;
    global _TimerPinOut : label;

//------------------------------------------
// size_t UnIntptTimerMode ( int timer_no );
//       ,
//   t0 ( t1 )    

    <_UnIntptTimerMode>
        push ar6;
        ar6 = ar7 - 4;
        gr7 = [ar6];  // gr7 = timer_no
        pop ar6
            with gr7;
        if =0 goto _UnIntptTimer0Mode;  //   0

    <_UnIntptTimer1Mode>
        gr7 = pswr;
        pswr set TM1;  //      1
                       //   
        return;

    <_UnIntptTimer0Mode>
        gr7 = pswr;
        pswr set TM0;  //      0
                       //   
        return;

//------------------------------------------
// size_t IntptTimerMode ( int timer_no );
//       ,
//     

    <_IntptTimerMode>
        push ar6;
        ar6 = ar7 - 4;
        gr7 = [ar6];  // gr7 = timer_no
        pop ar6
            with gr7;
        if =0 goto _IntptTimer0Mode;  //   0

    <_IntptTimer1Mode>
        gr7 = pswr;
        pswr clear TM1;  //      1
                         //   
        return;

    <_IntptTimer0Mode>
        gr7 = pswr;
        pswr clear TM0;  //      0
                         //   
        return;

//------------------------------------------
// size_t ClearTimerCtrl ( int timer_no );
//  ,  19 ( 17 )  PSWR  0

    <_ClearTimerCtrl>
        push ar6;
        ar6 = ar7 - 4;
        gr7 = [ar6];  // gr7 = timer_no
        pop ar6
            with gr7;
        if =0 goto _ClearTimer0Ctrl;  //   0

    <_ClearTimer1Ctrl>
        gr7 = pswr;
        pswr clear TE1;  //      1
        return;

    <_ClearTimer0Ctrl>
        gr7 = pswr;
        pswr clear TE0;  //      0
        return;

//------------------------------------------
// size_t SetTimerCtrl ( int timer_no );
//     19 ( 17 )  PSWR

    <_SetTimerCtrl>
        push ar6;
        ar6 = ar7 - 4;
        gr7 = [ar6];  // gr7 = timer_no
        pop ar6
            with gr7;
        if =0 goto _SetTimer0Ctrl;  //   0

    <_SetTimer1Ctrl>
        gr7 = pswr;
        pswr set TE1;    //      1
        return;

    <_SetTimer0Ctrl>
        gr7 = pswr;
        pswr set TE0;  //      0
        return;

//------------------------------------------
// size_t SetTimerCounter ( int timer_no, size_t CounterValue );
//   CounterValue   t0 ( t1 ),
//    t0 ( t1 )

    <_SetTimerCounter>
        push ar6;
        ar6 = ar7 - 4;
        gr7 = [ar6];  // gr7 = timer_no
        pop ar6
            with gr7;
        if =0 goto _SetCounterT0;  //   0

    <_SetCounterT1>
        push ar5;
        ar5 = ar7 - 5;
        gr7 = t1;
        t1 = [ar5];  //   CounterValue   t1
        pop ar5;
        return;

    <_SetCounterT0>
        push ar5;
        ar5 = ar7 - 5;
        gr7 = t0;
        t0 = [ar5];  //   CounterValue   t0
        pop ar5;
		return;

//------------------------------------------
// size_t GetTimerCounter ( int timer_no );
//     timer_no

    <_GetTimerCounter>
        push ar6;
        ar6 = ar7 - 4;
        gr7 = [ar6];  // gr7 = timer_no
        pop ar6
            with gr7;
        if =0 goto _GetCounterT0;  //   0

    <_GetCounterT1>
        gr7 = t1;
        return;

    <_GetCounterT0>
        gr7 = t0;
        return;

//------------------------------------------
// size_t TimerPinHalt ( void );
//  TIMER    

    <_TimerPinHalt>
        gr7 = pswr;
        pswr clear TEN;  //       TIMER
        return;

//------------------------------------------
// size_t TimerPinRelease ( void );
//     TIMER

    <_TimerPinRelease>
        gr7 = pswr;
        pswr set TEN;  //       TIMER
        return;

//------------------------------------------
// size_t TimerPinOut ( int det_out );
//  ,      TIMER

    <_TimerPinOut>
        push gr5;
        push ar6,gr6;
        ar6 = ar7 - 6;
        gr6 = [ar6];  // gr6 = det_out

        gr5 = tmp1;
        gr7 = pswr
            with gr6 = gr6 and gr5;
        pswr clear TPOC  //    ,
                         //     TIMER
            with gr6 = gr6 << 26;
        gr5 = pswr;
        pop ar6,gr6 with gr5 = gr5 or gr6;
        pswr = gr5; //     ,
                    //     TIMER
        pop gr5;
        return;

//------------------------------------------
end text;